Attribute VB_Name = "modFormat"
' This code was written by Andrea Tincani, and can be found at:
' http://www.andreavb.f2s.com/tip030004.html
' There's plenty of other useful code on the same web site.

Option Explicit

'API calls
Private Declare Function SHFormatDrive Lib "shell32" _
    (ByVal hwnd As Long, ByVal Drive As Long, _
    ByVal fmtID As Long, ByVal options As Long) As Long
Private Declare Function GetDriveType Lib "kernel32" _
    Alias "GetDriveTypeA" (ByVal nDrive As String) As Long

'Drive type constants
Private Const DRIVE_CDROM = 5
Private Const DRIVE_FIXED = 3
Private Const DRIVE_RAMDISK = 6
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_REMOVABLE = 2
Private Const SHFMT_ID_DEFAULT = &HFFFF ' Option bits for options parameter
Private Const SHFMT_OPT_QUICK = 0
Private Const SHFMT_OPT_FULL = 1
Private Const SHFMT_OPT_SYSONLY = 2

Public Sub FormatFloppy(hWndOwner As Long, ByVal DriveLetter As String)

    Dim DriveNum                As Long
    Dim DriveType               As Long
    Dim ret                     As Long

    ' Add the root path to the drive letter
    DriveLetter = Left(DriveLetter, 1) & ":\"
    
    ' Convert the drive letter into the corresponding drive number, A=0, B=1...
    DriveNum = Asc(UCase(DriveLetter)) - Asc("A")
    DriveType = GetDriveType(DriveLetter)
    
    ' Check if the drive is a floppy drive and act appropriately
    If DriveType = DRIVE_REMOVABLE Then
        ret = SHFormatDrive(hWndOwner, DriveNum, SHFMT_ID_DEFAULT, SHFMT_OPT_QUICK)
    Else
        MsgBox "Drive " & DriveLetter & " is not a floppy drive!", vbExclamation, "Format Floppy Disk"
    End If
    
End Sub

